///*********************************************************************
//    项目名称:MG82F6D17-DEMO
//    作    者:LZD
//			测试板使用 MG82F6D17 SSOP20_V10 EV Board (TH194A)
//			CpuCLK=32MHz, SysCLK=32MHz
//	功能描述：
//			PCA时钟: 96MHz
//			CH0(P22)/CH1(P33),CH2(P24)/CH3(P34),CH4(P17)/CH5(P35),CH6(P60)/CH7(P61)
//			4对互补,边沿对齐,分辨率为10bit
//			PWM频率: 96MHz/(1024)=93.750KHz
//	注意事项：
//
//    建立时间:
//    修改日志:
//    
//*********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6D17.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6D17.H"
#include ".\include\API_Uart_BRGRL_MG82F6D17.H"


///*************************************************
//定义系统时钟SysClk (MAX.50MHz)
//可选: 
//	11059200,12000000,
//	22118400,24000000,
//	29491200,32000000,
//	44236800,48000000
//*************************************************/
#define MCU_SYSCLK		32000000
/*************************************************/
///*************************************************
//定义CPU时钟 CpuClk (MAX.36MHz)
//	1) CpuCLK=SysCLK
//	2) CpuClk=SysClk/2
//*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define LED_G_0		P33
#define LED_R		P34
#define LED_G_1		P35


idata WordTypeDef wDuty[4];

///*************************************************
//函数名称:     void DelayXus(u16 xUs)
//功能描述:   	延时程序，单位为us
//输入参数:     u8 Us -> *1us  (1~255)
//输出参数:     
//*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

///*************************************************
//函数名称:     void DelayXms(u16 xMs)
//功能描述:     延时程序，单位为ms
//输入参数:     u16 xMs -> *1ms  (1~65535)
//输出参数:     
//*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}

///***********************************************************************************
//函数名称:   void InitPort(void)
//功能描述:   IO配置
//输入参数:   
//返回参数:     
//*************************************************************************************/
void InitPort(void)
{
	PORT_SetP1PushPull(BIT7);						// 设置P17(CEX4)为推挽输出
	PORT_SetP2PushPull(BIT2|BIT4);					// 设置P22(CEX0),P24(CEX2)为推挽输出
	PORT_SetP3PushPull(BIT3|BIT4|BIT5);				// 设置P33(CEX1),P34(CEX3),P35(CEX5)为推挽输出
	PORT_SetP6PushPull(BIT0|BIT1);					// 设置P60(PWM6),P61(PWM7)为推挽输出
}


///***********************************************************************************
//函数名称:   void InitPCA_PWM(void)
//功能描述:   PWM初始化
//输入参数:   
//返回参数:     
//*************************************************************************************/
void InitPCA_PWM(void)
{
	PCA_SetCLOCK_CKMIX16();			// 96MHz
	
	PCA_CH0_SetMode_PWM();
	PCA_CH1_SetMode_PWM();
	PCA_CH2_SetMode_PWM();
	PCA_CH3_SetMode_PWM();
	PCA_CH4_SetMode_PWM();
	PCA_CH5_SetMode_PWM();
	PCA_CH6_SetMode_PWM();
	PCA_CH7_SetMode_PWM();

	PCA_CH0_SetPWM_10Bit();
	PCA_CH1_SetPWM_10Bit();
	PCA_CH2_SetPWM_10Bit();
	PCA_CH3_SetPWM_10Bit();
	PCA_CH4_SetPWM_10Bit();
	PCA_CH5_SetPWM_10Bit();
	PCA_CH6_SetPWM_10Bit();
	PCA_CH7_SetPWM_10Bit();

	PCA_CH01_SetPWM_EnBufferMode();		// CH0,CH1 使能缓冲模式
	PCA_CH23_SetPWM_EnBufferMode();		// CH2,CH3 使能缓冲模式
	PCA_CH45_SetPWM_EnBufferMode();		// CH4,CH5 使能缓冲模式
	PCA_CH67_SetPWM_EnBufferMode();		// CH6,CH7 使能缓冲模式

	PCA_SetPWM_EdgeAligned();			// 边沿对齐

	// 设置PWM占空比比较值
	PCA_CH0_SetValue_10Bit(0,0);
	PCA_CH1_SetValue_10Bit(0,0);
	PCA_CH2_SetValue_10Bit(0,0);
	PCA_CH3_SetValue_10Bit(0,0);
	PCA_CH4_SetValue_10Bit(0,0);
	PCA_CH5_SetValue_10Bit(0,0);
	PCA_CH6_SetValue_10Bit(0,0);
	PCA_CH7_SetValue_10Bit(0,0);

	// 设置计数器
	PCA_SetCounter(0);
	PCA_SetCounterReload(0);

	// 禁止PWM输出
	PCA_SetPWM0_DisOutput();					
	PCA_SetPWM1_DisOutput();
	PCA_SetPWM2_DisOutput();
	PCA_SetPWM3_DisOutput();
	PCA_SetPWM4_DisOutput();
	PCA_SetPWM5_DisOutput();
	PCA_SetPWM6_DisOutput();
	PCA_SetPWM7_DisOutput();

	PCA_SetCEX0CEX2CEX4_P22P24P17();	// 设置CEX0:P22,CEX2:P24,CEX4:P17
	PCA_SetPWM6PWM7_P60P61();			// 设置PWM6:P60,PWM7:P61

	PCA_CF_DisInterrupt();				// 禁止CF中断

	PCA_EnPCACounter();					// 使能PCA计数器, 
}

///***********************************************************************************
//函数名称:   void InitClock(void)
//功能描述:   时钟初始化
//输入参数:   
//返回参数:     
//*************************************************************************************/
void InitClock(void)
{
#if (MCU_SYSCLK==11059200)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// SysClk=11.0592MHz CpuClk=11.0592MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1);
	
#else
	// SysClk=11.0592MHz CpuClk=5.5296MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1);
#endif
#endif

#if (MCU_SYSCLK==12000000)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// SysClk=12MHz CpuClk=12MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1);
	
#else
	// SysClk=12MHz CpuClk=6MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1);
#endif
#endif

#if (MCU_SYSCLK==22118400)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// SysClk=22.1184MHz CpuClk=22.1184MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx4, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4|OSCIn_IHRCO);
#else
	// SysClk=22.1184MHz CpuClk=11.0592MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx4, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4|OSCIn_IHRCO);
#endif
#endif

#if (MCU_SYSCLK==24000000)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// SysClk=24MHz CpuClk=24MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx4, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4|OSCIn_IHRCO);
#else
	// SysClk=24MHz CpuClk=12MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx4, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4|OSCIn_IHRCO);
#endif
#endif

#if (MCU_SYSCLK==29491200)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// Cpuclk high speed
	CLK_SetCpuCLK_HighSpeed();
	// SysClk=29.491200MHz CpuClk=29.491200MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx5.33, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X533|OSCIn_IHRCO);
#else
	// SysClk=29.491200MHz CpuClk=14.7456MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx5.33, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X533|OSCIn_IHRCO);
#endif
#endif

#if (MCU_SYSCLK==32000000)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// Cpuclk high speed
	CLK_SetCpuCLK_HighSpeed();
	// SysClk=32MHz CpuClk=32MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx5.33, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X533|OSCIn_IHRCO);
#else
	// SysClk=32MHz CpuClk=16MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx5.33, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X533|OSCIn_IHRCO);
#endif
#endif

#if (MCU_SYSCLK==36000000)
#if (MCU_CPUCLK==MCU_SYSCLK)
	// Cpuclk high speed
	CLK_SetCpuCLK_HighSpeed();
	// CKMIx6,x8,x12
	CLK_SetCKM_x6x8x12();	
	// SysClk=36MHz CpuClk=18MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx6, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4_X6|OSCIn_IHRCO);
#else
	// CKMIx6,x8,x12
	CLK_SetCKM_x6x8x12();	
	// SysClk=36MHz CpuClk=18MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx6, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X4_X6|OSCIn_IHRCO);
#endif
#endif


#if (MCU_SYSCLK==44236800)
	// SysClk=44.2368MHz CpuClk=22.1184MHz
	CLK_SetCKCON0(IHRCO_110592MHz|CPUCLK_SYSCLK_DIV_1|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx8, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X8|OSCIn_IHRCO);
#endif

#if (MCU_SYSCLK==48000000)
	// SysClk=48MHz CpuClk=24MHz
	CLK_SetCKCON0(IHRCO_12MHz|CPUCLK_SYSCLK_DIV_2|SYSCLK_MCKDO_DIV_1|ENABLE_CKM|CKM_OSCIN_DIV_2);
	DelayXus(100);
	// IHRCO, MCK=CKMIx8, OSCin=IHRCO
	CLK_SetCKCON2(ENABLE_IHRCO|MCK_CKMI_X8|OSCIn_IHRCO);
#endif

	// P60 输出 MCK/4
	//CLK_P60OC_MCKDiv4();
}





///***********************************************************************************
//函数名称:   void InitSystem(void)
//功能描述:   系统初始化
//输入参数:   
//返回参数:     
//*************************************************************************************/
void InitSystem(void)
{
	InitClock();
	InitPort();
	InitPCA_PWM();
}


void main()
{
	u8 inx;
	
    InitSystem();

	LED_G_0=0;LED_R=0;LED_G_1=0;
	DelayXms(1000);
	LED_G_0=1;LED_R=1;LED_G_1=1;

	// 使能PWM输出
	PCA_SetPWM0_EnOutput();					
	PCA_SetPWM1_EnOutput();
	PCA_SetPWM2_EnOutput();					
	PCA_SetPWM3_EnOutput();
	PCA_SetPWM4_EnOutput();					
	PCA_SetPWM5_EnOutput();
	PCA_SetPWM6_EnOutput();
	PCA_SetPWM7_EnOutput();
	inx=0;
	while(1)
    {
    	DelayXms(200);
    	inx++;
    	if(inx>=8)
    	{
			inx=0;
    	}
    	switch(inx)
    	{
			case 0:
				// 占空比100% 输出全高电平	
				wDuty[0].W=0x0000;
				wDuty[1].W=0x0000;
				wDuty[2].W=0x0000;
				wDuty[3].W=0x0000;
				break;

			case 1:
				// 占空比75% 	
				wDuty[0].W=0x0100;
				wDuty[1].W=0x0100;
				wDuty[2].W=0x0100;
				wDuty[3].W=0x0100;
				break;

			case 2:
				// 占空比50% 	
				wDuty[0].W=0x0200;
				wDuty[1].W=0x0200;
				wDuty[2].W=0x0200;
				wDuty[3].W=0x0200;
				break;

			case 3:
				// 占空比25% 	
				wDuty[0].W=0x0300;
				wDuty[1].W=0x0300;
				wDuty[2].W=0x0300;
				wDuty[3].W=0x0300;
				break;
				
			case 4:
				// 占空比0% 	 输出全低电平
				wDuty[0].W=0x0400;
				wDuty[1].W=0x0400;
				wDuty[2].W=0x0400;
				wDuty[3].W=0x0400;
				break;

			case 5:
				// 占空比25% 	
				wDuty[0].W=0x0300;
				wDuty[1].W=0x0300;
				wDuty[2].W=0x0300;
				wDuty[3].W=0x0300;
				break;

			case 6:
				// 占空比50% 	
				wDuty[0].W=0x0200;
				wDuty[1].W=0x0200;
				wDuty[2].W=0x0200;
				wDuty[3].W=0x0200;
				break;

			case 7:
				// 占空比75% 	
				wDuty[0].W=0x0100;
				wDuty[1].W=0x0100;
				wDuty[2].W=0x0100;
				wDuty[3].W=0x0100;
				break;
				
    	}
		// 缓冲模式下,CH0/CH1的重载值寄存器为CH1的值
		PCA_CH1_SetValue_10Bit(wDuty[0].B.BHigh,wDuty[0].B.BLow);
		// 缓冲模式下,CH2/CH3的重载值寄存器为CH3的值
		PCA_CH3_SetValue_10Bit(wDuty[1].B.BHigh,wDuty[1].B.BLow);
		// 缓冲模式下,CH4/CH5的重载值寄存器为CH5的值
		PCA_CH5_SetValue_10Bit(wDuty[2].B.BHigh,wDuty[2].B.BLow);
		// 缓冲模式下,CH6/CH7的重载值寄存器为CH7的值
		PCA_CH7_SetValue_10Bit(wDuty[3].B.BHigh,wDuty[3].B.BLow);
    }
}
